unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.Menus,
  IniFiles, MyUtility, ShellAPI, Mask, ShlObj, ActiveX, ComObj, Vcl.ComCtrls;


const
  FORM_WIDTH_SET       = 600;
  FORM_HEIGHT_SET      = 300;
  FORM_MAX             = 'MAX';
  FORM_MIN             = 'MIN';
  FORM_NORMAL          = 'NORMAL';

  FOLDER_LANGUAGE      = 'Language';

  LISTBOX1_WIDTH       = 600;

  HISTORY_MAX          = 8;

  FORM_LEFT_SHIFT      = 9;
  FORM_TOP_SHIFT       = 9;

  VK_0 = Ord('0');
  VK_1 = Ord('1');
  VK_2 = Ord('2');
  VK_3 = Ord('3');
  VK_4 = Ord('4');
  VK_5 = Ord('5');
  VK_6 = Ord('6');
  VK_7 = Ord('7');
  VK_8 = Ord('8');
  VK_9 = Ord('9');
  VK_A = Ord('A');
  VK_B = Ord('B');
  VK_C = Ord('C');
  VK_D = Ord('D');
  VK_E = Ord('E');
  VK_F = Ord('F');
  VK_G = Ord('G');
  VK_H = Ord('H');
  VK_I = Ord('I');
  VK_J = Ord('J');
  VK_K = Ord('K');
  VK_L = Ord('L');
  VK_M = Ord('M');
  VK_N = Ord('N');
  VK_O = Ord('O');
  VK_P = Ord('P');
  VK_Q = Ord('Q');
  VK_R = Ord('R');
  VK_S = Ord('S');
  VK_T = Ord('T');
  VK_U = Ord('U');
  VK_V = Ord('V');
  VK_W = Ord('W');
  VK_X = Ord('X');
  VK_Y = Ord('Y');
  VK_Z = Ord('Z');
  VK_COMMA      = 188; // #$BC
  VK_PIRIOD     = 190; // #$BE
  VK_SLASH      = 191; // #$BF
  VK_BACKSLASH  = 226; // #$E2
  VK_SEMICOLLON = 187; // #$BB
  VK_COLLON     = 186; // #$BA
  VK_RIGHT_KAGI = 221; // #$DD ]
  VK_AT_MARK    = 192; // #$C0
  VK_LEFT_KAGI  = 219; // #&DB [
  VK_MINUS      = 189; // #$BD
  VK_HATTO      = 222; // #$DE
  VK_YEN        = 220; // #$DC

type
  TFormMain = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    ButtonStart: TButton;
    ButtonStop: TButton;
    ButtonQuit: TButton;
    ListBox1: TListBox;
    ButtonOpen: TButton;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    ButtonRead: TButton;
    Timer1: TTimer;
    MainMenu1: TMainMenu;
    MenuFile: TMenuItem;
    MenuQuit: TMenuItem;
    MenuSetting: TMenuItem;
    MenuCloseXkey: TMenuItem;
    MenuCloseQkey: TMenuItem;
    MenuCloseESCkey: TMenuItem;
    ComboBox1: TComboBox;
    MenuAutoStart: TMenuItem;
    MenuAutoClose: TMenuItem;
    Timer2: TTimer;
    MenuJpnEng: TMenuItem;
    MenuJapanese: TMenuItem;
    MenuEnglish: TMenuItem;

    procedure CreateParams(var Params: TCreateParams); override;
    procedure WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo); message WM_GETMINMAXINFO;

    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);

    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);

    procedure ButtonStopClick(Sender: TObject);
    procedure ButtonOpenClick(Sender: TObject);
    procedure ButtonQuitClick(Sender: TObject);
    procedure ButtonReadClick(Sender: TObject);
    procedure ButtonStartClick(Sender: TObject);

    procedure MenuQuitClick(Sender: TObject);
    procedure MenuCloseESCkeyClick(Sender: TObject);
    procedure MenuCloseQkeyClick(Sender: TObject);
    procedure MenuCloseXkeyClick(Sender: TObject);
    procedure MenuAutoStartClick(Sender: TObject);
    procedure MenuAutoCloseClick(Sender: TObject);

    function  ExecuteProgramByMacro(sExeName: String; sOption: String; sFileName: String; sChangeFolderName: String): Boolean;

    procedure MenuJapaneseClick(Sender: TObject);
    procedure MenuEnglishClick(Sender: TObject);

    procedure SetJapanese(FormThis: TForm; FileName: String; Sender: TObject);
    procedure SetEnglish(FormThis: TForm; FileName: String; Sender: TObject);
    function CheckLanguageFile(FileName: String; Sender: TObject): Boolean;
    function IsNumericStr(const Str:string): Boolean;
    procedure SetMenuCaption(FormThis: TForm; StrTag: String; StrCaption: String);
    procedure SetLabelButtonPanelTabsheetGroupboxCaption(FormThis: TForm; StrTag: String; StrCaption: String);
    procedure SetEditText(FormThis: TForm; StrTag: String; StrText: String);
    procedure SetListBoxItem(FormThis: TForm; StrTag: String; StrItem: String);
    procedure SetListBoxClear(FormThis: TForm; StrTag: String);
    procedure SetRadioGroupCaption(FormThis: TForm; StrTag: String; StrCaption: String);
    procedure SetRadioGroupItem(FormThis: TForm; StrTag: String; StrItem: String);
    procedure SetRadioGroupClear(FormThis: TForm; StrTag: String);
    procedure SetCheckBoxCaption(FormThis: TForm; StrTag: String; StrCaption: String);
    procedure SetComboBoxItem(FormThis: TForm; StrTag: String; StrItem: String);
    procedure SetComboBoxClear(FormThis: TForm; StrTag: String);
    procedure SetFormCaption(FormThis: TForm; StrTag: String; StrCaption: String);

  private
    { Private 錾 }
    StrListRunMacro: TStringList;
    BoolStop: Boolean;

    FormPosLeft: Integer;
    FormPosTop: Integer;
    FormPosWidth: Integer;
    FormPosHeight: Integer;
    FormPosRight: Integer;
    FormPosButtom: Integer;

    MonitorTop: Integer;
    MonitorLeft: Integer;
    MonitorRight: Integer;
    MonitorButtom: Integer;
    MonitorWidth: Integer;
    MonitorHeight: Integer;

    StrFormState: String;

    StrLanguageFileName: String;
  public
    { Public 錾 }
    StrMsg: String;
    StrSystemFontNameJpn: String;
    IntSystemFontSizeJpn: Integer;
    StrSystemFontNameEng: String;
    IntSystemFontSizeEng: Integer;
    BoolJapanese: Boolean;
  end;

var
  FormMain: TFormMain;

implementation

{$R *.dfm}

//NbNɃtH[ANeBuɂ邽߂ɕKv
procedure TFormMain.CreateParams(var Params: TCreateParams);
begin
  inherited;
  Params.WndParent := Application.Handle;
end;

procedure TFormMain.WmGetMinMaxInfo(var msg : TWMGetMinMaxInfo);
begin
  //ŏTCY
  with msg.MinMaxInfo^.ptMinTrackSize do
  begin
    x := FORM_WIDTH_SET;
    y := FORM_HEIGHT_SET;
  end;
  //őTCY
  with msg.MinMaxInfo^.ptMaxTrackSize do
  begin
    //
  end;
  //ő剻TCY
  with msg.MinMaxInfo^.ptMaxSize do
  begin
    //
  end;
end;

procedure TFormMain.FormClose(Sender: TObject; var Action: TCloseAction);
var
  IniFile: TIniFile;
  iRow1: Integer;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //ʏ
  if WindowState = wsMaximized then
  begin
    IniFile.WriteString('FormMain', 'State', FORM_MAX);
  end
  else if WindowState = wsMinimized then
  begin
    IniFile.WriteString('FormMain', 'State', FORM_MIN);
  end
  else
  begin
    IniFile.WriteString ('FormMain', 'State',  FORM_NORMAL);
    IniFile.WriteInteger('FormMain', 'Left',   FormMain.Left);
    IniFile.WriteInteger('FormMain', 'Top',    FormMain.Top);
    IniFile.WriteInteger('FormMain', 'Width',  FormMain.Width);
    IniFile.WriteInteger('FormMain', 'Height', FormMain.Height);
  end;

  //ۑ
  IniFile.WriteString ('Main',       'OpenFileName',  ComboBox1.Text);
  for iRow1 := 0 to HISTORY_MAX-1 do
  begin
    IniFile.WriteString ('OpenFileName',  IntToStr(iRow1), ComboBox1.Items.Strings[iRow1]);
  end;

  //j
  IniFile.Free;

  //f
  if ButtonStop.Enabled = TRUE then
  begin
    ButtonStopClick(Sender);
  end;
end;

procedure TFormMain.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
;
end;

procedure TFormMain.FormCreate(Sender: TObject);
var
  IniFile: TIniFile;
  iRow1: Integer;
  sStr1: String;
  StrList1: TStringList;
begin
  // Unicode(UTF-16)t@C쐬Ă
  sStr1 := ChangeFileExt(Application.ExeName, '.ini');
  if FileExists(sStr1) = FALSE then
  begin
    StrList1 := TStringList.Create;
    try
      StrList1.SaveToFile(sStr1, TEncoding.Unicode);
    finally
      StrList1.Free;
    end;
  end;

  //m
  StrListRunMacro := TStringList.Create;

  //
  Timer1.Enabled := FALSE;
  Timer2.Enabled := FALSE;
  BoolStop := FALSE;
  ButtonStop.Enabled := FALSE;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //tH[ʒu
  FormPosLeft   := IniFile.ReadInteger('FormMain', 'Left',   0);
  FormPosTop    := IniFile.ReadInteger('FormMain', 'Top',    0);
  FormPosWidth  := IniFile.ReadInteger('FormMain', 'Width',  FORM_WIDTH_SET);
  FormPosHeight := IniFile.ReadInteger('FormMain', 'Height', FORM_HEIGHT_SET);
  StrFormState  := IniFile.ReadString ('FormMain', 'State',  FORM_NORMAL);
  FormPosRight  := FormPosLeft + FormPosWidth;
  FormPosButtom := FormPosTop  + FormPosHeight;

  //擾
  ComboBox1.Text               :=          IniFile.ReadString ('Main', 'OpenFileName', '');
  MenuCloseEsckey.Checked      :=          IniFile.ReadBool   ('Main',       'CloseESCkey',   TRUE);
  MenuCloseQkey.Checked        :=          IniFile.ReadBool   ('Main',       'CloseQkey',     TRUE);
  MenuCloseXkey.Checked        :=          IniFile.ReadBool   ('Main',       'CloseXkey',     TRUE);
  MenuAutoStart.Checked        :=          IniFile.ReadBool   ('Main',       'AutoStart',     FALSE);
  MenuAutoClose.Checked        :=          IniFile.ReadBool   ('Main',       'AutoClose',     FALSE);

  for iRow1 := 0 to HISTORY_MAX-1 do
  begin
    ComboBox1.Items.Add(IniFile.ReadString ('OpenFileName',  IntToStr(iRow1), ''));
  end;

  //j
  IniFile.Free;

  //MessageDialog ̉΍
  UseLatestCommonDialogs := FALSE;

  //
  if ParamCount = 1 then
  begin
    ComboBox1.Text := ParamStr(1);
  end;

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));

  //擾
  BoolJapanese           := IniFile.ReadBool ('Language',      'Japanese',  TRUE);
  if BoolJapanese = TRUE then
  begin
    MenuJapanese.Checked := TRUE;
    MenuEnglish.Checked  := FALSE;
  end
  else
  begin
    MenuJapanese.Checked := FALSE;
    MenuEnglish.Checked  := TRUE;
  end;
  //ݒ
  StrSystemFontNameJpn := IniFile.ReadString ('SystemFontJpn', 'Name', 'lr SVbN');
  StrSystemFontNameEng := IniFile.ReadString ('SystemFontEng', 'Name', 'Courier New');
  IntSystemFontSizeJpn := IniFile.ReadInteger('SystemFontJpn', 'Size', 14);
  IntSystemFontSizeEng := IniFile.ReadInteger('SystemFontEng', 'Size', 12);
  IniFile.WriteString ('SystemFontJpn', 'Name', StrSystemFontNameJpn);
  IniFile.WriteString ('SystemFontEng', 'Name', StrSystemFontNameEng );
  IniFile.WriteInteger('SystemFontJpn', 'Size', IntSystemFontSizeJpn);
  IniFile.WriteInteger('SystemFontEng', 'Size', IntSystemFontSizeEng);

  //j
  IniFile.Free;

  //fBNg쐬
  if ForceDirectories(ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\') = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      StrMsg := 'Error : tH_쐬ł܂ł' + #13#10 +
                 ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\';
    end
    else
    begin
      StrMsg := 'Error : Folder can not make.' + #13#10 +
                '[OK]' + #13#10 +
                 ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\';
    end;
    ShowMessage(StrMsg);
  end;

  //fBNg쐬
  if ForceDirectories(ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\' + ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\') = FALSE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      StrMsg := 'Error : tH_쐬ł܂ł' + #13#10 +
                 ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\' + ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\';
    end
    else
    begin
      StrMsg := 'Error : Folder can not make.' + #13#10 +
                '[OK]' + #13#10 +
                 ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE + '\' + ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\';
    end;
    ShowMessage(StrMsg);
  end;
end;

procedure TFormMain.FormDestroy(Sender: TObject);
begin
  //j
  StrListRunMacro.Free;
end;

procedure TFormMain.FormKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  //ESC
  if      (Shift = []) and (key = VK_ESCAPE) then
  begin
    if (MenuCloseESCkey.Checked = TRUE) then
    begin
      //
      Close;
    end;
  end
  //Q
  else if (Shift = []) and (key = VK_Q) then
  begin
    if (MenuCloseQkey.Checked = TRUE) then
    begin
      //
      Close;
    end;
  end
  //X
  else if (Shift = []) and (key = VK_X) then
  begin
    if (MenuCloseXkey.Checked = TRUE) then
    begin
      //
      Close;
    end;
  end
  //
  else
  begin
    //
  end;
end;

procedure TFormMain.FormResize(Sender: TObject);
begin
  ComboBox1.Width := Panel1.ClientWidth - 165;
;
end;

procedure TFormMain.FormShow(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //FormłȂ̂ŁACreatełȂShowōs
  //FormKeyDowñCxgݒ肷
  FormMain.KeyPreview := TRUE;

  //GetSystemMetricst֐gpāCzʑŜ̃TCY擾
  MonitorTop    := GetSystemMetrics(SM_YVIRTUALSCREEN);
  MonitorLeft   := GetSystemMetrics(SM_XVIRTUALSCREEN);
  MonitorWidth  := GetSystemMetrics(SM_CXVIRTUALSCREEN);
  MonitorHeight := GetSystemMetrics(SM_CYVIRTUALSCREEN);
  MonitorRight  := MonitorLeft + MonitorWidth;
  MonitorButtom := MonitorTop  + MonitorHeight;

  //\ł ȌԂŕ\
  if ( (MonitorTop  <= FormPosTop  + FORM_TOP_SHIFT ) and (FormPosTop    <= MonitorButtom) ) and
     ( (MonitorTop  <= FormPosButtom                ) and (FormPosButtom <= MonitorButtom) ) and
     ( (MonitorLeft <= FormPosLeft + FORM_LEFT_SHIFT) and (FormPosLeft   <= MonitorRight ) ) and
     ( (MonitorLeft <= FormPosRight                 ) and (FormPosRight  <= MonitorRight ) ) then
  begin
    FormMain.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end
  //ʓɕ\łȂ ftHgŕ\
  else
  begin
    FormMain.SetBounds(FormPosLeft, FormPosTop, FormPosWidth, FormPosHeight);
  end;

  //ő
  if StrFormState = FORM_MAX then
  begin
    FormMain.WindowState := wsMaximized;
  end
  //ŏ
  else if StrFormState = FORM_MIN then
  begin
    FormMain.WindowState := wsMinimized;
  end
  //W
  else
  begin
    //
  end;

  //IMEIt
  SetImeMode(FormMain.Handle, imClose);

  //XN[o[\
  ListBox1.Perform (LB_SETHORIZONTALEXTENT, LISTBOX1_WIDTH * 2, 0);

  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //j
  IniFile.Free;

  //
  if (ParamCount = 1) and (MenuAutoStart.Checked = TRUE) then
  begin
    Timer2.Enabled := TRUE;
  end;

  //ݒ
  StrLanguageFileName := ExtractFilePath(ParamStr(0)) + FOLDER_LANGUAGE  + '\' +
                         ChangeFileExt(ExtractFileName(ParamStr(0)), '') + '\' + 'Main.txt';
  if FormMain.BoolJapanese = TRUE then
  begin
    //{
    FormMain.SetJapanese(FormMain, StrLanguageFileName, Sender);
  end
  else
  begin
    //p
    FormMain.SetEnglish(FormMain, StrLanguageFileName, Sender);
  end;
end;

procedure TFormMain.MenuAutoCloseClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuAutoClose.Checked = TRUE then
  begin
    MenuAutoClose.Checked := FALSE;
  end
  else
  begin
    MenuAutoClose.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Main', 'AutoClose',      MenuAutoClose.Checked);
  //j
  IniFile.Free;
end;

procedure TFormMain.MenuAutoStartClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuAutoStart.Checked = TRUE then
  begin
    MenuAutoStart.Checked := FALSE;
  end
  else
  begin
    MenuAutoStart.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Main', 'AutoStart',      MenuAutoStart.Checked);
  //j
  IniFile.Free;
end;

procedure TFormMain.MenuCloseESCkeyClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuCloseESCkey.Checked = TRUE then
  begin
    MenuCloseESCkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseESCkey.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Main', 'CloseESCkey',      MenuCloseEsckey.Checked);
  //j
  IniFile.Free;
end;

procedure TFormMain.MenuCloseQkeyClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuCloseQkey.Checked = TRUE then
  begin
    MenuCloseQkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseQkey.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Main', 'CloseQkey',      MenuCloseQkey.Checked);
  //j
  IniFile.Free;
end;

procedure TFormMain.MenuCloseXkeyClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  if MenuCloseXkey.Checked = TRUE then
  begin
    MenuCloseXkey.Checked := FALSE;
  end
  else
  begin
    MenuCloseXkey.Checked := TRUE;
  end;
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool  ('Main', 'CloseXkey',      MenuCloseXkey.Checked);
  //j
  IniFile.Free;
end;

procedure TFormMain.MenuQuitClick(Sender: TObject);
begin
      //I
      ButtonQuitClick(Sender);
end;

procedure TFormMain.ButtonOpenClick(Sender: TObject);
begin
  OpenDialog1.InitialDir := ExtractFilePath(ComboBox1.Text);
  OpenDialog1.FileName := ExtractFileName(ComboBox1.Text);
  if OpenDialog1.Execute() = TRUE then
  begin
    ComboBox1.Text := OpenDialog1.FileName;
  end
end;

procedure TFormMain.ButtonQuitClick(Sender: TObject);
begin
  Close;
end;

procedure TFormMain.ButtonReadClick(Sender: TObject);
var
  iRow1: Integer;
  sStr1: String;
  sStr2: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr15: String;
begin
  //t@C݂
  if FileExists(ComboBox1.Text) then
  begin
    //NA
    ListBox1.Items.Clear;

    //Ǎ
    FormMain.StrListRunMacro.LoadFromFile(ComboBox1.text);
    for iRow1 := 0 to FormMain.StrListRunMacro.Count-1 do
    begin
      //擾
      sStr1 := FormMain.StrListRunMacro.Strings[iRow1];

      //R
      if Length(sStr1) = 3 then
      begin
          //=KR
          if UpperCase(Copy(sStr1, 1, 3)) = UpperCase('-KR')  then
          begin
            //1. -KR
            //2. svOLq(tpX)
            //tpX̎svȎO"/"LqƁAJgtH_
            //̎svÔtH_ɈړĂs܂B
            //3. svOɓnp[^Lq
            //4. t@C̎w
            //s"/"̂ : Jg܂̓^Ot@C
            //s"/Q" : Jg܂̓^Ot@C""łăvOɓn
            //擪"/"Ȃ : t@CwȂ
            //
            //1sڂ́u-KRvAK4sLqĂB
            //^Ot@ĆAst@C̃R}hCɗ񂳂܂̂ŁA
            //R}hC̒(256jȏ̃t@CnꍇAsł܂B
            //2sڂ̐擪"/"Ȃꍇ́AannsFMŕ\ĂtH_
            //JgtH_ƂĎw肳ꂽsvOs܂B

            sStr11 := FormMain.StrListRunMacro.Strings[iRow1+0];
            sStr12 := FormMain.StrListRunMacro.Strings[iRow1+1];
            sStr13 := FormMain.StrListRunMacro.Strings[iRow1+2];
            sStr14 := FormMain.StrListRunMacro.Strings[iRow1+3];

            sStr15 := sStr11 + #09 + sStr12 + #09 + sStr13 + #09 + sStr14 + #09 + #09;
            ListBox1.Items.Add(sStr15);
          end;
      end;
      //S
      if Length(sStr1) = 4 then
      begin
          //=-EWT
          if UpperCase(Copy(sStr1, 1, 4)) = UpperCase('-EWT')  then
          begin
            //1. -EWT
            //2. 
            //҂ԂmsI[_[ŋLqB(1b = 1000)
            //ő10b܂Őݒł܂B10bȏݒ肵ꍇ́A10bƂȂ܂B

            sStr11 := FormMain.StrListRunMacro.Strings[iRow1+0];
            sStr12 := FormMain.StrListRunMacro.Strings[iRow1+1];

            sStr15 := sStr11 + #09 + sStr12 + #09 + #09 + #09 + #09;
            ListBox1.Items.Add(sStr15);
          end;
        end;
    end;

    //폜
    sStr2 := ComboBox1.Text;
    for iRow1 := 0 to ComboBox1.Items.Count-1 do
    begin
      if UpperCase(ComboBox1.Items.Strings[iRow1]) = UpperCase(sStr2) then
      begin
        ComboBox1.Items.Delete(iRow1);
      end;
    end;
    //擪ɒǉ
    ComboBox1.Items.Insert(0, sStr2);
    ComboBox1.Text := sStr2;

  end;
end;

procedure TFormMain.ButtonStartClick(Sender: TObject);
var
  iRow1: Integer;
  iRow11: Integer;
  CsvList1: TStringList;
  sStr1: String;
  sStr11: String;
  sStr12: String;
  sStr13: String;
  sStr14: String;
  sStr21: String;
  sStr22: String;
  sStr23: String;
  sStr25: String;
begin
  if ListBox1.Items.Count = 0 then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      StrMsg := 'Information : t@Cǂݍ܂Ă܂';
    end
    else
    begin
      StrMsg := 'Information : File is not read.' +  #13#10 +
                '[OK]';
    end;
    ShowMessage(StrMsg);
    Exit;
  end;

  //m
  CsvList1 := TStringList.Create;

  //
  BoolStop := FALSE;
  Timer1.Enabled := FALSE;
  ButtonStop.Enabled  := TRUE;
  ButtonOpen.Enabled  := FALSE;
  ButtonRead.Enabled  := FALSE;
  ButtonStart.Enabled := FALSE;
  ButtonQuit.Enabled  := FALSE;


  //s
  for iRow1 := 0 to ListBox1.Items.Count-1 do
  begin
    //f
    if BoolStop = TRUE then
    begin
      Break;
    end;

    //^C}[s̓[v
    while TRUE do
    begin
      for iRow11 := 0 to 100 do
      begin
        Application.ProcessMessages;
      end;
      if Timer1.Enabled = FALSE then
      begin
        Break;
      end;
    end;

    //f
    if BoolStop = TRUE then
    begin
      Break;
    end;

    //擾
    CsvList1.clear;
    sStr1 := ListBox1.Items.Strings[iRow1];
    StringToCsvList(sStr1, CsvList1);

    //J[\ړ
    ListBox1.ItemIndex := iRow1;

    //s
    if CsvList1.Count >= 2 then
    begin
      //-KR
      if UpperCase(CsvList1.Strings[0]) = UpperCase('-KR') then
      begin
            //1. -KR
            //2. svOLq(tpX)
            //tpX̎svȎO"/"LqƁAJgtH_
            //̎svÔtH_ɈړĂs܂B
            //3. svOɓnp[^Lq
            //4. t@C̎w
            //s"/"̂ : Jg܂̓^Ot@C
            //s"/Q" : Jg܂̓^Ot@C""łăvOɓn
            //擪"/"Ȃ : t@CwȂ
            //
            //1sڂ́u-KRvAK4sLqĂB
            //^Ot@ĆAst@C̃R}hCɗ񂳂܂̂ŁA
            //R}hC̒(256jȏ̃t@CnꍇAsł܂B
            //2sڂ̐擪"/"Ȃꍇ́AannsFMŕ\ĂtH_
            //JgtH_ƂĎw肳ꂽsvOs܂B

        //^C}[N
        Timer1.Interval := 2000;
        Timer1.Enabled  := TRUE;

        //擾
        sStr11 := CsvList1.Strings[0];
        sStr12 := CsvList1.Strings[1];
        sStr13 := CsvList1.Strings[2];
        sStr14 := CsvList1.Strings[3];

        //t@C͓nȂ

        //st@C
        if Length(sStr12) > 0 then
        begin
          //t@Cw
          if UpperCase(Copy(sStr12, 1, 1)) = '/' then
          begin
            //st@C̃pX
            sStr21 := ExtractFilePath(Copy(sStr12, 2, Length(sStr12)));
            //st@C
            sStr22 := Copy(sStr12, 2, Length(sStr12));
            //IvV
            sStr23 := sStr13;
            //t@C
            sStr25 := '';
          end
          else
          begin
            //݂̃pX
            sStr21 := '';
            //st@C
            sStr22 := sStr12;
            //IvV
            sStr23 := sStr13;
            //t@C
            sstr25 := '';
          end;
        end
        else
        begin
            //pX
            sStr21 := '';
            //st@C
            sStr22 := '';
            //IvV
            sStr23 := '';
            //t@C
            sStr25 := '';
        end;

            //showmessage(sStr22 + #13#10 + sStr23 + #13#10 + sStr25 + #13#10 + sStr21);

        //s
        if sStr22  <> '' then
        begin
          //ExecuteProgram(sExeName: String; sOption: String; sFileName: String; sChangeFolderName: String): Boolean;
          FormMain.ExecuteProgramByMacro(sStr22, sStr23, sStr25, sStr21);
        end;

      end;

      //-EWT
      if UpperCase(CsvList1.Strings[0]) = UpperCase('-EWT') then
      begin
        //^C}[N
        Timer1.Interval := StrToInt(CsvList1.Strings[1]);
        Timer1.Enabled  := TRUE;
      end;
    end;
  end;
  //j
  CsvList1.Free;

  //Đݒ
  ButtonStop.Enabled  := FALSE;
  ButtonOpen.Enabled  := TRUE;
  ButtonRead.Enabled  := TRUE;
  ButtonStart.Enabled := TRUE;
  ButtonQuit.Enabled  := TRUE;

  //XV
  if BoolStop = TRUE then
  begin
    //ݒ
    if BoolJapanese = TRUE then
    begin
      StrMsg := 'Information : f܂';
    end
    else
    begin
      StrMsg := 'Information : Operation had stopped.' +  #13#10 +
                '[OK]';
    end;
    ShowMessage(StrMsg);
  end
  else
  begin
    //
    if (ParamCount = 1) and (MenuAutoClose.Checked = TRUE) then
    begin
      //I
      ButtonQuitClick(Sender);
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        StrMsg := 'Information : ܂';
      end
      else
      begin
        StrMsg := 'Information : Operation had finished.' +  #13#10 +
                 '[OK]';
      end;
      ShowMessage(StrMsg);
    end;
  end;

end;

procedure TFormMain.ButtonStopClick(Sender: TObject);
begin
  BoolStop := TRUE;
  ButtonStop.Enabled  := FALSE;
  ButtonOpen.Enabled  := TRUE;
  ButtonRead.Enabled  := TRUE;
  ButtonStart.Enabled := TRUE;
  ButtonQuit.Enabled  := TRUE;
  if Timer1.Enabled = TRUE then
  begin
    Timer1.Enabled := FALSE;
  end;
end;

function TFormMain.ExecuteProgramByMacro(sExeName: String; sOption: String; sFileName: String; sChangeFolderName: String): Boolean;
var
  iErr1: Integer;
  bRet1: Boolean;
  sStr2: String;
  sStr5: String;
begin
  //st@C
  sStr2 := sExeName;
  //擪ƍŌ " U폜
  if (Copy(sStr2, 1, 1) = '"') and (Copy(sStr2, Length(sStr2), 1) = '"') then
  begin
    sStr2 := Copy(sStr2, 2, Length(sStr2)-2);
  end;
  //ExeȂ
  if FileExists(sStr2) = FALSE then
  begin
    //s
    Result := FALSE;
    //f
    Exit;
  end;

  //IvVݒ
  sStr5 := sOption;

  //t@C
  if sFileName <> '' then
  begin
    //
    if (sChangeFolderName <> '') and (DirectoryExists(sChangeFolderName) = TRUE) then
    begin
      //JgύX
      ChDir(sChangeFolderName);
      //N
      iErr1 := ShellExecute(Handle,
                            'open',
                            PWideChar('"' + sStr2 + '"'),
                            PWideChar(sStr5 + ' ' + sFileName),
                            PWideChar(sChangeFolderName),
                            SW_SHOWDEFAULT);
    end
    else
    begin
      //N
      iErr1 := ShellExecute(Handle,
                            'open',
                            PWideChar('"' + sStr2 + '"'),
                            PWideChar(sStr5 + ' ' + sFileName),
                            nil,
                            SW_SHOWDEFAULT);
    end;
  end
  //t@CȂ
  else
  begin
    //
    if (sChangeFolderName <> '') and (DirectoryExists(sChangeFolderName) = TRUE) then
    begin
      //JgύX
      ChDir(sChangeFolderName);
      //N
      iErr1 := ShellExecute(Handle,
                            'open',
                            PWideChar('"' + sStr2 + '"'),
                            PWideChar(sStr5),
                            PWideChar(sChangeFolderName),
                            SW_SHOWDEFAULT);
    end
    else
    begin
      //N
      iErr1 := ShellExecute(Handle,
                            'open',
                            PWideChar('"' + sStr2 + '"'),
                            PWideChar(sStr5),
                            nil,
                            SW_SHOWDEFAULT);
    end;
  end;

  //vO̎sɎs
  if iErr1 <= 32 then
  begin
    bRet1 := FALSE;
  end
  else
  begin
    bRet1 := TRUE;
  end;
  Result := bRet1;
end;

procedure TFormMain.Timer1Timer(Sender: TObject);
begin
  //Zbg
  Timer1.Enabled := FALSE;
end;

procedure TFormMain.Timer2Timer(Sender: TObject);
begin
  //Zbg
  Timer2.Enabled := FALSE;
  //Ǎ
  ButtonReadClick(Sender);
  //Jn
  ButtonStartClick(Sender);
end;

procedure TFormMain.MenuJapaneseClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool   ('Language',      'Japanese',  TRUE);
  //j
  IniFile.Free;

  //ݒ
  MenuJapanese.Checked := TRUE;
  MenuEnglish.Checked  := FALSE;
  BoolJapanese         := TRUE;

  //{
  FormMain.SetJapanese(FormMain, StrLanguageFileName, Sender);
end;

procedure TFormMain.MenuEnglishClick(Sender: TObject);
var
  IniFile: TIniFile;
begin
  //m
  IniFile := TIniFile.Create (ChangeFileExt(ParamStr(0), '.ini'));
  //
  IniFile.WriteBool   ('Language',      'Japanese',  FALSE);
  //j
  IniFile.Free;

  //ݒ
  MenuJapanese.Checked := FALSE;
  MenuEnglish.Checked  := TRUE;
  BoolJapanese         := FALSE;

  //p
  FormMain.SetEnglish(FormMain, StrLanguageFileName, Sender);
end;

procedure TFormMain.SetJapanese(FormThis: TForm; FileName: String; Sender: TObject);
var
  sListBox1: String;
  sRadioGroup1: String;
  sComboBox1: String;
  iRow1: Integer;
  StrList1: TStringList;
  CsvList1: TStringList;
begin
  ///m
  StrList1 := TStringList.Create;
  CsvList1 := TStringList.Create;

  //݂
  if FileExists(FileName) = TRUE then
  begin
    //mF
    if CheckLanguageFile(FileName, Sender) = TRUE then
    begin
      //Ǎ
      StrList1.LoadFromFile(FileName, TEncoding.Unicode);
      //s
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        //NA
        CsvList1.Clear;
        //WJ
        StringToCsvList(StrList1.Strings[iRow1], CsvList1);  //MyUtilityKv
        //Menu
        if (Copy(CsvList1[0], 1, 1) = '1') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetMenuCaption(FormThis, CsvList1[0], CsvList1[4]);
        end;
        //Label, Button, Panel, GroupBox
        if (Copy(CsvList1[0], 1, 1) = '2') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetLabelButtonPanelTabsheetGroupboxCaption(FormThis, CsvList1[0], CsvList1[4]);
        end;
        //Form
        if (Copy(CsvList1[0], 1, 4) = '2999') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetFormCaption(FormThis, CsvList1[0], CsvList1[4]);
        end;
        //ListBox
        if (Copy(CsvList1[0], 1, 1) = '4') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          if sListBox1 <> CsvList1[0] then
          begin
            SetListBoxClear(FormThis, CsvList1[0]);
            SetListBoxItem (FormThis, CsvList1[0], CsvList1[4]);
            sListBox1 := CsvList1[0];
          end
          else
          begin
            SetListBoxItem (FormThis, CsvList1[0], CsvList1[4]);
          end;
        end;
        //RadioGroup
        if (Copy(CsvList1[0], 1, 1) = '5') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetRadioGroupCaption(FormThis, CsvList1[0], CsvList1[4]);
        end;
        //RadioGroup
        if (Copy(CsvList1[0], 1, 1) = '5') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          if sRadioGroup1 <> CsvList1[0] then
          begin
            SetRadioGroupClear(FormThis, CsvList1[0]);
            SetRadioGroupItem (FormThis, CsvList1[0], CsvList1[4]);
            sRadioGroup1 := CsvList1[0];
          end
          else
          begin
            SetRadioGroupItem (FormThis, CsvList1[0], CsvList1[4]);
          end;
        end;
        //CheckBox
        if (Copy(CsvList1[0], 1, 1) = '6') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetCheckBoxCaption(FormThis, CsvList1[0], CsvList1[4]);
        end;
        //ComboBox
        if (Copy(CsvList1[0], 1, 1) = '7') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          if sComboBox1 <> CsvList1[0] then
          begin
            SetComboBoxClear(FormThis, CsvList1[0]);
            SetComboBoxItem (FormThis, CsvList1[0], CsvList1[4]);
            sComboBox1 := CsvList1[0];
          end
          else
          begin
            SetComboBoxItem (FormThis, CsvList1[0], CsvList1[4]);
          end;
        end;
        //Edit
        if (Copy(CsvList1[0], 1, 1) = '8') and (CsvList1[1] = '1') and (CsvList1[3] = 'Text') then
        begin
          SetEditText(FormThis, CsvList1[0], CsvList1[4]);
        end;
      end;

      //tHg
      FormThis.Font.Name := StrSystemFontNameJpn;
      FormThis.Font.Size := IntSystemFontSizeJpn;
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        StrMsg := 'Error : ݒt@Csł';
      end
      else
      begin
        StrMsg := 'Error : This language file format is wrong.' + #13#10 +
                  '[OK]';
      end;
      ShowMessage(StrMsg);
    end;
  end;

  //j
  StrList1.Free;
  CsvList1.Free;
end;

procedure TFormMain.SetEnglish(FormThis: TForm; FileName: String; Sender: TObject);
var
  sListBox1: String;
  sRadioGroup1: String;
  sComboBox1: String;
  iRow1: Integer;
  StrList1: TStringList;
  CsvList1: TStringList;
begin
  ///m
  StrList1 := TStringList.Create;
  CsvList1 := TStringList.Create;

  //݂
  if FileExists(FileName) = TRUE then
  begin
    //mF
    if CheckLanguageFile(FileName, Sender) = TRUE then
    begin
      //Ǎ
      StrList1.LoadFromFile(FileName,TEncoding.Unicode);
      //s
      for iRow1 := 0 to StrList1.Count-1 do
      begin
        //NA
        CsvList1.Clear;
        //WJ
        StringToCsvList(StrList1.Strings[iRow1], CsvList1);  //MyUtilityKv

        //Menu
        if (Copy(CsvList1[0], 1, 1) = '1') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetMenuCaption(FormThis, CsvList1[0], CsvList1[5]);
        end;
        //Label, Button, Panel,Groupbox
        if (Copy(CsvList1[0], 1, 1) = '2') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetLabelButtonPanelTabsheetGroupboxCaption(FormThis, CsvList1[0], CsvList1[5]);
        end;
        //Form
        if (Copy(CsvList1[0], 1, 4) = '2999') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetFormCaption(FormThis, CsvList1[0], CsvList1[5]);
        end;
        //ListBox
        if (Copy(CsvList1[0], 1, 1) = '4') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          //ŏ̏
          if sListBox1 <> CsvList1[0] then
          begin
            SetListBoxClear(FormThis, CsvList1[0]);
            SetListBoxItem (FormThis, CsvList1[0], CsvList1[5]);
            sListBox1 := CsvList1[0];
          end
          //ŏȍ~̏
          else
          begin
            SetListBoxItem (FormThis, CsvList1[0], CsvList1[5]);
          end;
        end;
        //RadioGroup
        if (Copy(CsvList1[0], 1, 1) = '5') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetRadioGroupCaption(FormThis, CsvList1[0], CsvList1[5]);
        end;
        //RadioGroup
        if (Copy(CsvList1[0], 1, 1) = '5') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          //ŏ̏
          if sRadioGroup1 <> CsvList1[0] then
          begin
            SetRadioGroupClear(FormThis, CsvList1[0]);
            SetRadioGroupItem (FormThis, CsvList1[0], CsvList1[5]);
            sRadioGroup1 := CsvList1[0];
          end
          //ŏȍ~̏
          else
          begin
            SetRadioGroupItem (FormThis, CsvList1[0], CsvList1[5]);
          end;
        end;
        //CheckBox
        if (Copy(CsvList1[0], 1, 1) = '6') and (CsvList1[1] = '1') and (CsvList1[3] = 'Caption') then
        begin
          SetCheckBoxCaption(FormThis, CsvList1[0], CsvList1[5]);
        end;
        //ComboBox
        if (Copy(CsvList1[0], 1, 1) = '7') and (CsvList1[1] = '1') and (CsvList1[3] = 'Item') then
        begin
          //ŏ̏
          if sComboBox1 <> CsvList1[0] then
          begin
            SetComboBoxClear(FormThis, CsvList1[0]);
            SetComboBoxItem (FormThis, CsvList1[0], CsvList1[5]);
            sComboBox1 := CsvList1[0];
          end
          //ŏȍ~̏
          else
          begin
            SetComboBoxItem (FormThis, CsvList1[0], CsvList1[5]);
          end;
        end;
        //Edit
        if (Copy(CsvList1[0], 1, 1) = '8') and (CsvList1[1] = '1') and (CsvList1[3] = 'Text') then
        begin
          SetEditText(FormThis, CsvList1[0], CsvList1[5]);
        end;
      end;
      //tHg
      FormThis.Font.Name := StrSystemFontNameEng;
      FormThis.Font.Size := IntSystemFontSizeEng;
    end
    else
    begin
      //ݒ
      if BoolJapanese = TRUE then
      begin
        StrMsg := 'Error : ݒt@Csł';
      end
      else
      begin
        StrMsg := 'Error : This language file format is wrong.' + #13#10 +
                  '[OK]';
      end;
      ShowMessage(StrMsg);
    end;
  end;

  //j
  StrList1.Free;
  CsvList1.Free;
end;

procedure TFormMain.SetMenuCaption(FormThis: TForm; StrTag: String; StrCaption: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TMenuItem(FormThis.Components[iRow1]).Caption := StrCaption;
      Break;
    end;
  end;
end;

procedure TFormMain.SetLabelButtonPanelTabsheetGroupboxCaption(FormThis: TForm; StrTag: String; StrCaption: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      if (FormThis.Components[iRow1].Tag >= 2001) and (FormThis.Components[iRow1].Tag < 2201) then
      begin
        TLabel(FormThis.Components[iRow1]).Caption := StrCaption;
        Break;
      end;
      if (FormThis.Components[iRow1].Tag >= 2201) and (FormThis.Components[iRow1].Tag < 2401) then
      begin
        TButton(FormThis.Components[iRow1]).Caption := StrCaption;
        Break;
      end;
      if (FormThis.Components[iRow1].Tag >= 2401) and (FormThis.Components[iRow1].Tag < 2601) then
      begin
        TPanel(FormThis.Components[iRow1]).Caption := StrCaption;
        Break;
      end;
      if (FormThis.Components[iRow1].Tag >= 2601) and (FormThis.Components[iRow1].Tag < 2801) then
      begin
        TTabSheet(FormThis.Components[iRow1]).Caption := StrCaption;
        Break;
      end;
      if (FormThis.Components[iRow1].Tag >= 2801) and (FormThis.Components[iRow1].Tag < 3000) then
      begin
        TGroupBox(FormThis.Components[iRow1]).Caption := StrCaption;
        Break;
      end;
    end;
  end;
end;

procedure TFormMain.SetEditText(FormThis: TForm; StrTag: String; StrText: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TEdit(FormThis.Components[iRow1]).Text := StrText;
      Break;
    end;
  end;
end;

procedure TFormMain.SetListBoxItem(FormThis: TForm; StrTag: String; StrItem: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TListBox(FormThis.Components[iRow1]).Items.Add(StrItem);
      Break;
    end;
  end;
end;

procedure TFormMain.SetListBoxClear(FormThis: TForm; StrTag: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TListBox(FormThis.Components[iRow1]).Items.Clear;
      Break;
    end;
  end;
end;

procedure TFormMain.SetRadioGroupCaption(FormThis: TForm; StrTag: String; StrCaption: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TRadioGroup(FormThis.Components[iRow1]).Caption := StrCaption;
      Break;
    end;
  end;
end;

procedure TFormMain.SetRadioGroupItem(FormThis: TForm; StrTag: String; StrItem: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TRadioGroup(FormThis.Components[iRow1]).Items.Add(StrItem);
      Break;
    end;
  end;
end;

procedure TFormMain.SetRadioGroupClear(FormThis: TForm; StrTag: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TRadioGroup(FormThis.Components[iRow1]).Items.Clear;
      Break;
    end;
  end;
end;

procedure TFormMain.SetCheckBoxCaption(FormThis: TForm; StrTag: String; StrCaption: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TCheckBox(FormThis.Components[iRow1]).Caption := StrCaption;
      Break;
    end;
  end;
end;

procedure TFormMain.SetComboBoxItem(FormThis: TForm; StrTag: String; StrItem: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TComboBox(FormThis.Components[iRow1]).Items.Add(StrItem);
      Break;
    end;
  end;
end;

procedure TFormMain.SetComboBoxClear(FormThis: TForm; StrTag: String);
var
  iRow1: Integer;
begin
  for iRow1 := 0 to FormThis.ComponentCount -1 do
  begin
    if FormThis.Components[iRow1].Tag = StrToInt(StrTag) then
    begin
      TComboBox(FormThis.Components[iRow1]).Items.Clear;
      Break;
    end;
  end;
end;

procedure TFormMain.SetFormCaption(FormThis: TForm; StrTag: String; StrCaption: String);
begin
  FormThis.Caption := StrCaption;
end;

function TFormMain.CheckLanguageFile(FileName: String; Sender: TObject): Boolean;
var
  StrList1: TStringList;
  CsvList1: TStringList;
  iRow1: Integer;
begin
  Result := TRUE;
  StrList1 := TStringList.Create;
  CsvList1 := TStringList.Create;
  if FileExists(FileName)  = TRUE then
  begin
    StrList1.LoadFromFile(Filename, TEncoding.Unicode);
    for iRow1 := 0 to StrList1.Count -1 do
    begin
      //WJ
      CsvList1.Clear;
      StringToCsvList(StrList1.Strings[iRow1], CsvList1);
      //mF
      if CsvList1.Count <> 6 then
      begin
        Result := FALSE;
        Break;
      end;
      //mF
      if UpperCase(CsvList1[0]) = UpperCase('Tag') then
      begin
        //
      end
      //TagȊO
      else
      begin
        //ȊO
        if IsNumericStr(CsvList1[0]) = FALSE then
        begin
          Result := FALSE;
          Break;
        end;
      end;
    end;
  end;
  StrList1.Free;
  CsvList1.Free;
end;

function TFormMain.IsNumericStr(const Str:string): Boolean;
var
  iPos1: Integer;
begin
  Result:= TRUE;
  for iPos1 := 1 to Length(Str) do
  begin
    if      Str[iPos1] = '0' then
    begin
    end
    else if Str[iPos1] = '1' then
    begin
    end
    else if Str[iPos1] = '2' then
    begin
    end
    else if Str[iPos1] = '3' then
    begin
    end
    else if Str[iPos1] = '4' then
    begin
    end
    else if Str[iPos1] = '5' then
    begin
    end
    else if Str[iPos1] = '6' then
    begin
    end
    else if Str[iPos1] = '7' then
    begin
    end
    else if Str[iPos1] = '8' then
    begin
    end
    else if Str[iPos1] = '9' then
    begin
    end
    else
    begin
      Result:= FALSE;
      Break;
    end;
  end;
end;


end.
